"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Header = void 0;
const react_1 = require("@chakra-ui/react");
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const react_2 = __importDefault(require("react"));
const TwitterLink_1 = require("./TwitterLink");
const WalletModalButton_1 = require("./WalletModalButton");
const MenuItem = (_a) => {
    var { children, isLast = false, href = "/" } = _a, rest = __rest(_a, ["children", "isLast", "href"]);
    return (react_2.default.createElement(react_1.Text, { mb: { base: isLast ? 0 : 8, sm: 0 }, mr: { base: 0, sm: isLast ? 0 : 8 }, display: "block" },
        react_2.default.createElement(react_1.Link, Object.assign({ href: href }, rest), children)));
};
const Header = () => {
    const { disconnect, connected } = (0, wallet_adapter_react_1.useWallet)();
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(react_1.Center, { zIndex: 100, position: "fixed", w: "full", height: "56px", alignItems: "center", color: "white", bg: "black.300" },
            react_2.default.createElement(react_1.Container, { maxW: "container.lg", w: "full", display: "flex", justifyContent: "space-between" },
                react_2.default.createElement(react_1.Link, { href: "/bounties" },
                    react_2.default.createElement(react_1.Image, { alt: "Strata Marketplace", src: "/logo.svg" })),
                react_2.default.createElement(react_1.Box, { display: { md: "block" }, flexBasis: { base: "100%", md: "auto" } },
                    react_2.default.createElement(react_1.HStack, { align: "center", justify: ["center", "space-between", "flex-end", "flex-end"], direction: ["column", "row", "row", "row"], display: ["none", "none", "flex"], pt: [4, 4, 0, 0] },
                        react_2.default.createElement(TwitterLink_1.TwitterLink, null),
                        connected && (react_2.default.createElement(react_1.Button, { _hover: { backgroundColor: "black.500" }, variant: "ghost", onClick: () => disconnect() }, "Disconnect")),
                        react_2.default.createElement(WalletModalButton_1.WalletModalButton, null))))),
        react_2.default.createElement(react_1.Box, { height: "56px" })));
};
exports.Header = Header;
//# sourceMappingURL=Header.js.map