"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetadataMeta = void 0;
const react_1 = __importDefault(require("react"));
const MetadataMeta = ({ name, description, image, cardType = "summary" }) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("title", null, name),
        react_1.default.createElement("meta", { property: "og:type", content: "website" }),
        react_1.default.createElement("meta", { name: "description", content: description }),
        react_1.default.createElement("meta", { property: "og:title", content: name }),
        react_1.default.createElement("meta", { property: "og:image", content: image }),
        react_1.default.createElement("meta", { property: "og:description", content: description }),
        react_1.default.createElement("link", { rel: "icon", href: "/favicon.ico" }),
        react_1.default.createElement("meta", { name: "twitter:card", content: cardType }),
        react_1.default.createElement("meta", { property: "twitter:domain", content: "marketplace.strataprotocol.com" }),
        react_1.default.createElement("meta", { name: "twitter:title", content: name }),
        react_1.default.createElement("meta", { name: "twitter:description", content: description }),
        react_1.default.createElement("meta", { name: "twitter:image", content: image })));
};
exports.MetadataMeta = MetadataMeta;
//# sourceMappingURL=MetadataMeta.js.map