"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Wallet = exports.DEFAULT_ENDPOINT = void 0;
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const wallet_adapter_wallets_1 = require("@solana/wallet-adapter-wallets");
const react_1 = __importStar(require("react"));
// export const DEFAULT_ENDPOINT = "https://wumbo.genesysgo.net";
exports.DEFAULT_ENDPOINT = process.env.NEXT_PUBLIC_SOLANA_URL || "https://api.devnet.solana.com";
const Wallet = ({ children, cluster }) => {
    // @solana/wallet-adapter-wallets includes all the adapters but supports tree shaking and lazy loading --
    // Only the wallets you configure here will be compiled into your application, and only the dependencies
    // of wallets that your users connect to will be loaded
    const wallets = (0, react_1.useMemo)(() => [
        new wallet_adapter_wallets_1.PhantomWalletAdapter(),
        new wallet_adapter_wallets_1.SlopeWalletAdapter(),
        new wallet_adapter_wallets_1.SolflareWalletAdapter(),
        new wallet_adapter_wallets_1.TorusWalletAdapter(),
        new wallet_adapter_wallets_1.LedgerWalletAdapter(),
        new wallet_adapter_wallets_1.SolletWalletAdapter({}),
        new wallet_adapter_wallets_1.SolletExtensionWalletAdapter({}),
    ], []);
    return (react_1.default.createElement(wallet_adapter_react_1.ConnectionProvider, { endpoint: cluster || exports.DEFAULT_ENDPOINT },
        react_1.default.createElement(wallet_adapter_react_1.WalletProvider, { wallets: wallets, autoConnect: true }, children)));
};
exports.Wallet = Wallet;
//# sourceMappingURL=Wallet.js.map