"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCapInfo = void 0;
const react_1 = require("@strata-foundation/react");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const useCapInfo = (tokenBondingKey) => {
    const { info: tokenBonding, loading: loadingBonding } = (0, react_1.useTokenBonding)(tokenBondingKey);
    const targetMintAcct = (0, react_1.useMint)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.targetMint);
    const targetMintSupply = targetMintAcct && (0, spl_token_bonding_1.toNumber)(targetMintAcct.supply, targetMintAcct);
    const mintCap = tokenBonding &&
        targetMintAcct &&
        tokenBonding.mintCap &&
        (0, spl_token_bonding_1.toNumber)(tokenBonding.mintCap, targetMintAcct);
    const numRemaining = typeof targetMintSupply != "undefined" && !!mintCap
        ? mintCap - targetMintSupply
        : undefined;
    return {
        loading: loadingBonding,
        numRemaining,
        mintCap
    };
};
exports.useCapInfo = useCapInfo;
//# sourceMappingURL=useCapInfo.js.map